Index: trunk/src/lib/util/loading/resource_manager.h
===================================================================
--- trunk/src/lib/util/loading/resource_manager.h	(revision 9682)
+++ trunk/src/lib/util/loading/resource_manager.h	(revision 9869)
@@ -1,157 +1,87 @@
 /*!
  * @file resource_manager.h
-  *  The Resource Manager checks if a file/resource is loaded.
-
-    If a file/resource was already loaded the resourceManager will
-    return a void pointer to the desired resource.
-    Otherwise it will instruct the coresponding resource-loader to load,
-    and receive a pointer to it.
-
-    it is possible to compile the resource Manager without some modules by
-    just adding the compile flag -D....
-    (NO_MODEL)
-    (NO_AUDIO)
-    (NO_TEXT)
-    (NO_TEXTURES)
-    (NO_SHADERS)
-*/
+ */
 
 #ifndef _RESOURCE_MANAGER_H
 #define _RESOURCE_MANAGER_H
 
-#include "base_object.h"
+#include "resource.h"
 #include "filesys/file.h"
+#include "filesys/directory.h"
 
-#include "multi_type.h"
-#include <vector>
+namespace Resources
+{
 
-//! An eumerator for different fileTypes the resourceManager supports
-typedef enum ResourceType
-{
-#ifndef NO_MODEL
-  OBJ,                  //!< loading .obj file
-  PRIM,                 //!< loading primitive model
-  MD2,                  //!< loading md2-file
-  MD3,                  //!< loading md3-file
-  MD3_CONFIG,           //!< the md3 config file
-#endif /* NO_MODEL */
-#ifndef NO_TEXT
-  TTF,                  //!< loading a TrueTypeFont
-#endif /* NO_TEXT */
-#ifndef NO_AUDIO
-  WAV,                  //!< loading wav
-  MP3,                  //!< loading mp3
-  OGG,                  //!< loading ogg
-#endif /* NO_AUDIO */
-#ifndef NO_TEXTURES
-  IMAGE,                //!< loading an image
-#endif /* NO_TEXTURES */
-#ifndef NO_SHADERS
-  SHADER,               //!< openGL-shader program
-#endif /* NO_SHADERS */
-  RESOURCE_TYPE_SIZE
-};
+  class ResourceManager : public BaseObject
+  {
+    ObjectListDeclaration(ResourceManager);
+  public:
+    ///////////////////////
+    //// INSTANZIATION ////
+    /** @returns a Pointer to the only object of this Class */
+    inline static ResourceManager* getInstance() { if (!_singletonRef) _singletonRef = new ResourceManager();  return _singletonRef; };
+    /** @brief deletes the Instance if it exists. */
+    inline static void deleteInstance() { if (_singletonRef) delete _singletonRef; };
 
-//! An enumerator for different UNLOAD-types.
-/**
-   RP_NO:        will be unloaded on request
-   RP_LEVEL:     will be unloaded at the end of a Level
-   RP_CAMPAIGN:  will be unloaded at the end of a Campaign
-   RP_GAME:      will be unloaded at the end of the whole Game (when closing orxonox)
-*/
-typedef enum ResourcePriority
-{
-  RP_NO        =   0,
-  RP_LEVEL     =   1,
-  RP_CAMPAIGN  =   2,
-  RP_GAME      =   4
-};
+    ////////////////////////
+    //// RESOURCE PATHS ////
+    void setMainGlobalPath(const Directory& directory);
+    void addGlobalPath(const Directory& directory);
 
-//! A Struct that keeps track about a resource its name its Type, and so on
-struct Resource
-{
-  BaseObject*       pointer;           //!< Pointer to the Resource.
-  unsigned int      count;             //!< How many times this Resource has been loaded.
+    bool addResourcePath(const std::string& resourceName, const std::string& pathName);
+    bool addResourceSubPath(const std::string& resourceName, const std::string& pathName);
+    void registerType(Resources::Type* type);
+    void unregisterType(Resources::Type* type);
 
-  std::string       name;              //!< Name of the Resource.
-  ResourceType      type;              //!< ResourceType of this Resource.
-  ResourcePriority  prio;              //!< The Priority of this resource. (This will only be increased)
+    /** @returns the main global search Path */
+    const Directory& mainGlobalPath() const { return _mainGlobalPath; };
+    /** @returns all global paths without mainGlobalPath */
+    const std::vector<Directory>& globalPaths() const { return _globalPaths; };
 
-  MultiType         param[3];          //!< The Parameters given to this Resource.
-};
+    ////////////////////
+    //// KEEPLEVELS ////
+    unsigned int addKeepLevelName(const std::string& keepLevelName);
+    unsigned int getKeepLevelID(const std::string& keepLevelName) const;
+    const std::string& getKeepLevelName(unsigned int keepLevelID) const;
+    void setDefaultKeepLevel(const KeepLevel& keepLevel) { this->_defaultKeepLevel = keepLevel; };
+    const KeepLevel& defaultKeepLevel() const { return this->_defaultKeepLevel; };
 
+    //////////////////////////
+    //// GENERAL QUERIES ////
+    /** @returns the Types of Resources */
+    const std::vector<Resources::Type*> resourceTypes() const { return _resourceTypes; };
 
-//! The ResourceManager is a class, that decides if a file/resource should be loaded
-/**
- * If a file/resource was already loaded the resourceManager will
- * return a pointer to the desired resource.
- * Otherwise it will instruct the corresponding resource-loader to load,
- * and receive the pointer to it.
- *
- * It does it by looking, if a desired file has already been loaded.
- * There is also the possibility to check for some variables
- */
-class ResourceManager : public BaseObject
-{
- public:
-  virtual ~ResourceManager();
-  /** @returns a Pointer to the only object of this Class */
-  inline static ResourceManager* getInstance() { if (!singletonRef) singletonRef = new ResourceManager();  return singletonRef; };
+    bool checkFileInMainPath(const File& fileInside);
+    std::string prependAbsoluteMainPath(const std::string& fileName);
 
-  bool setDataDir(const std::string& dataDir);
-  /** @returns the Name of the data directory */
-  inline const std::string& getDataDir() const { return this->dataDir; };
+    ////////////////////////////////////////
+    //// RESOURCE LOADING AND UNLOADING ////
+    void loadFromLoadString(const std::string& resourceTypeName, const std::string& loadString, const KeepLevel& keepLevel = KeepLevel());
+    void loadFromLoadStringHACK(const std::string& resourceTypeName, const std::string& loadString) { this->loadFromLoadString(resourceTypeName, loadString); };
 
+    void unloadAllBelowKeepLevel(const Resources::KeepLevel& keepLevel);
+    void unloadAllBelowKeepLevelINT(unsigned int level) { unloadAllBelowKeepLevel(level); };
 
-  bool tryDataDir(const std::string& dataDir);
-  bool verifyDataDir(const std::string& fileInside);
-  bool addImageDir(const std::string& imageDir);
+    ///////////////
+    //// DEBUG ////
+    void debug() const;
 
-  bool cache(const std::string& fileName, ResourceType type, ResourcePriority prio = RP_NO,
-             const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
-  BaseObject* copy(BaseObject* resourcePointer);
+  private:
+    ResourceManager();
+    virtual ~ResourceManager();
 
-  BaseObject* load(const std::string& fileName, ResourcePriority prio = RP_NO,
-                   const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
-  BaseObject* load(const std::string& fileName, ResourceType type, ResourcePriority prio = RP_NO,
-                   const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
-  bool unload(BaseObject* pointer, ResourcePriority prio = RP_NO);
-  bool unload(Resource* resource, ResourcePriority = RP_NO);
-  bool unloadAllByPriority(ResourcePriority prio);
+  private:
+    static ResourceManager*            _singletonRef;       //!< singleton Reference
 
-  Resource* locateResourceByInfo(const std::string& fileName, ResourceType type,
-                                 const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType()) const;
-  Resource* locateResourceByPointer(const void* pointer) const;
+    Directory                          _mainGlobalPath;     //!< The main include directory (default at "./")
+    std::vector<Directory>             _globalPaths;        //!< Additional Global include directories.
 
-  std::string toResourcableString(unsigned int i);
-  bool fromResourceableString(const std::string& resourceableString);
-  /** @returns the Count of Resources the ResourceManager handles */
-  unsigned int resourceCount() const { return this->resourceList.size(); }
+    std::vector<Resources::Type*>      _resourceTypes;      //!< A Vector of all the stored ResourceTypes @see Resources::Type
 
-  void debug() const;
+    std::vector<std::string>           _keepLevelNames;     //!< Names of KeepLevels @see Resources::KeepLevel
+    KeepLevel                          _defaultKeepLevel;   //!< The default KeepLevel.
+  };
 
-
-  // utility functions for handling files in and around the data-directory
-  static std::string getFullName(const std::string& fileName);
-  static bool isInDataDir(const std::string& fileName);
-
-  static const char* ResourceTypeToChar(ResourceType type);
-  static ResourceType stringToResourceType(const std::string& resourceType);
-
- private:
-  ResourceManager();
-  Resource* loadResource(const std::string& fileName, ResourceType type, ResourcePriority prio,
-                         const MultiType& param0, const MultiType& param1, const MultiType& param2);
-
- private:
-  static ResourceManager*    singletonRef;       //!< singleton Reference
-
-  std::string                dataDir;            //!< The Data Directory, where all relevant Data is stored.
-  std::vector<std::string>   imageDirs;          //!< A list of directories in which images are stored.
-
-  std::vector<Resource*>     resourceList;       //!< The List of Resources, that has already been loaded.
-
-  static const char*         resourceNames[RESOURCE_TYPE_SIZE];
-};
+}
 
 #endif /* _RESOURCE_MANAGER_H */
Index: trunk/src/lib/util/multi_type.cc
===================================================================
--- trunk/src/lib/util/multi_type.cc	(revision 9682)
+++ trunk/src/lib/util/multi_type.cc	(revision 9869)
@@ -33,21 +33,21 @@
   {
     default:
-      this->value.Float = 0.0f;
-      break;
+    this->value.Float = 0.0f;
+    break;
     case MT_BOOL:
-      this->value.Bool = false;
-      break;
+    this->value.Bool = false;
+    break;
     case MT_INT:
-      this->value.Int = 0;
-      break;
+    this->value.Int = 0;
+    break;
     case MT_FLOAT:
-      this->value.Float = 0.0f;
-      break;
+    this->value.Float = 0.0f;
+    break;
     case MT_CHAR:
-      this->value.Char = '\0';
-      break;
+    this->value.Char = '\0';
+    break;
     case MT_STRING:
-      this->storedString = "";
-      break;
+    this->storedString = "";
+    break;
   }
 }
@@ -142,17 +142,17 @@
   {
     case MT_NULL:
-      return true;
+    return true;
     case MT_BOOL:
-      return (this->value.Bool == mt.value.Bool);
+    return (this->value.Bool == mt.value.Bool);
     case MT_INT:
-      return (this->value.Int == mt.value.Int);
+    return (this->value.Int == mt.value.Int);
     case MT_CHAR:
-      return (this->value.Char == mt.value.Char);
+    return (this->value.Char == mt.value.Char);
     case MT_FLOAT:
-      return (this->value.Float == mt.value.Float);
+    return (this->value.Float == mt.value.Float);
     case MT_STRING:
-      return (this->storedString == mt.storedString);
+    return (this->storedString == mt.storedString);
     default:
-      return false;
+    return false;
   }
 }
@@ -171,20 +171,20 @@
   {
     case MT_BOOL:
-      this->setBool(this->getBool());
-      break;
+    this->setBool(this->getBool());
+    break;
     case MT_INT:
-      this->setInt(this->getInt());
-      break;
+    this->setInt(this->getInt());
+    break;
     case MT_FLOAT:
-      this->setFloat(this->getFloat());
-      break;
+    this->setFloat(this->getFloat());
+    break;
     case MT_CHAR:
-      this->setChar(this->getChar());
-      break;
+    this->setChar(this->getChar());
+    break;
     case MT_STRING:
-      this->setString(this->getString());
-      break;
+    this->setString(this->getString());
+    break;
     default:
-      this->type = type;
+    this->type = type;
   }
 }
@@ -195,6 +195,4 @@
  *
  * This is a pure Value copy. The current type will be preserved.
- *
- * @TODO speedup
  */
 void MultiType::setValueOf(const MultiType& mt)
@@ -257,4 +255,13 @@
 }
 
+/**
+ * @brief stores any value to the string.
+ * @note this Value can be grabbed by using the getStoredString function.
+ */
+void MultiType::storeString()
+{
+  if (!(this->type & MT_STRING))
+    this->storedString = this->getString();
+}
 
 /**************************
@@ -275,5 +282,5 @@
   else if (this->type & MT_STRING) return (this->storedString == "true" ||
                                             this->storedString == "TRUE" ||
-                                            this->storedString != "0"); //! @TODO make this better...
+                                            this->storedString != "0"); // TODO make this better...
 
   return false;
@@ -381,13 +388,30 @@
  * @brief returns a Constant string (actually this is slower than getString()
  * @returns a constant string of the stored version's one.
- * @note this  could lead to a inconsistency of data
+ * @note this  could lead to a inconsistency of data AND IS HIGHLY NON_THREAD_SAFE!
+ * PLEASE THINK ABOUT USING THE getStoredString function in conjunction with storeString().
  */
 const std::string& MultiType::getConstString() const
 {
-
   MultiType::constString = this->getString();
   return MultiType::constString;
 }
 
+/**
+ * @brief returns the currently stored string.
+ * @returns the Stored string.
+ * @note Storing a string works as follows: \\
+ * MultiType a(3);  // Creates a MultiType of Type int with value 3 \\
+ * a.storeString(); // Stores the String in the internal structure. \\
+ * std::string name = a.getStoredString();
+ *
+ * This would be the same as
+ * name = a.getString();
+ * but with much more const'ness.
+ */
+const std::string& MultiType::getStoredString() const
+{
+  MultiType::constString = this->getString();
+  return MultiType::constString;
+}
 
 /**
@@ -433,23 +457,23 @@
   {
     case MT_BOOL:
-      this->setBool(false);
-      break;
+    this->setBool(false);
+    break;
     case MT_INT:
-      this->setInt(0);
-      break;
+    this->setInt(0);
+    break;
     case MT_FLOAT:
-      this->setFloat(0.0f);
-      break;
+    this->setFloat(0.0f);
+    break;
     case MT_CHAR:
-      this->setChar('\0');
-      break;
+    this->setChar('\0');
+    break;
     case MT_STRING:
-      this->setString("");
-      break;
+    this->setString("");
+    break;
     default:
 #ifdef DEBUG
-      PRINTF(2)("Unknown Type not reseting\n");
+    PRINTF(2)("Unknown Type not reseting\n");
 #endif
-      break;
+    break;
   }
 }
@@ -465,15 +489,15 @@
   {
     case MT_BOOL:
-      return MultiType::typeNames[1];
+    return MultiType::typeNames[1];
     case MT_INT:
-      return MultiType::typeNames[2];
+    return MultiType::typeNames[2];
     case MT_FLOAT:
-      return MultiType::typeNames[3];
+    return MultiType::typeNames[3];
     case MT_CHAR:
-      return MultiType::typeNames[4];
+    return MultiType::typeNames[4];
     case MT_STRING:
-      return MultiType::typeNames[5];
+    return MultiType::typeNames[5];
     default:
-      return MultiType::typeNames[0];
+    return MultiType::typeNames[0];
   }
 }
Index: trunk/src/lib/util/multi_type.h
===================================================================
--- trunk/src/lib/util/multi_type.h	(revision 9682)
+++ trunk/src/lib/util/multi_type.h	(revision 9869)
@@ -17,6 +17,6 @@
   MT_BOOL            = 1,                  //!< A bool Value.
   MT_INT             = 2,                  //!< An int Value.
-  MT_UINT            = 2,
-  MT_LONG            = 2,
+  MT_UINT            = 2,                  //!< A insigned int Value.
+  MT_LONG            = 2,                  //!< A long Value
   MT_FLOAT           = 4,                  //!< A float Value.
   MT_CHAR            = 8,                  //!< A single char.
@@ -44,17 +44,29 @@
 
     MultiType& operator=(const MultiType& mt);
+    /** @param value the value to set (here a bool) @returns the MultiType where this the bool is stored */
     MultiType& operator=(bool value) { this->setBool(value); return *this; };
+    /** @param value the value to set (here an int) @returns the MultiType where this the int is stored */
     MultiType& operator=(int value) { this->setInt(value); return *this; };
+    /** @param value the value to set (here an int) @returns the MultiType where this the float is stored */
     MultiType& operator=(float value) { this->setFloat(value); return *this; };
+    /** @param value the value to set (here a char) @returns the MultiType where this the char is stored */
     MultiType& operator=(char value) { this->setChar(value); return *this; };
+    /** @param value the value to set (here a string) @returns the MultiType where this the string is stored */
     MultiType& operator=(const std::string& value) { this->setString(value); return *this; };
 
     bool operator==(const MultiType& mt) const;
+    /** @param value the value to compare this MultiType against @returns true if comparison was io */
     bool operator==(bool value) const { return (this->getBool() == value); };
+    /** @param value the value to compare this MultiType against @returns true if comparison was io */
     bool operator==(int value) const { return (this->getInt() == value); };
+    /** @param value the value to compare this MultiType against @returns true if comparison was io */
     bool operator==(float value) const { return (this->getFloat() ==  value); };
+    /** @param value the value to compare this MultiType against @returns true if comparison was io */
     bool operator==(char value) const { return (this->getChar() == value); };
+    /** @param value the value to compare this MultiType against @returns true if comparison was io */
     bool operator==(const std::string& value) const { return (this->getString() == value); };
+    /** @param type the Type to compare this MultiType against @returns true if the types matched */
     bool operator==(MT_Type type) const { return (this->type == type); }
+    /** @param type the type to compare this MultiType against @returns true if the types do not match */
     bool operator!=(MT_Type type) const { return (this->type != type); }
 
@@ -68,9 +80,15 @@
 
     // for your convenience.
+    /** @param value the value to set. Here a bool */
     inline void setValue(bool value) { this->setBool(value); };
+    /** @param value the value to set. Here an int */
     inline void setValue(int value) { this->setInt(value); };
+    /** @param value the value to set. Here a float */
     inline void setValue(float value) { this->setFloat(value); };
+    /** @param value the value to set. Here a char */
     inline void setValue(char value) { this->setChar(value); };
+    /** @param value the value to set. Here a char array (string) */
     inline void setValue(const char* value) { this->setString(value); };
+    /** @param value the value to set. Here a string */
     inline void setValue(const std::string& value) { this->setString(value); };
     void setValueOf(const MultiType& mt);
@@ -79,4 +97,5 @@
     inline MT_Type getType() const { return this->type; };
 
+    void storeString();
 
     /* RETRIEVING FUNCTIONS */
@@ -88,4 +107,5 @@
     std::string getString() const;
     const std::string& getConstString() const;
+    const std::string& getStoredString() const;
 
     void reset();
Index: trunk/src/lib/util/sigslot/signal.h
===================================================================
--- trunk/src/lib/util/sigslot/signal.h	(revision 9682)
+++ trunk/src/lib/util/sigslot/signal.h	(revision 9869)
@@ -96,4 +96,5 @@
   {
   public:
+    virtual ~_connection_base0() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit() = 0;
@@ -106,4 +107,5 @@
   {
   public:
+    virtual ~_connection_base1() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type) = 0;
@@ -116,4 +118,5 @@
   {
   public:
+    virtual ~_connection_base2() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type) = 0;
@@ -126,4 +129,5 @@
   {
   public:
+    virtual ~_connection_base3() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type) = 0;
@@ -136,4 +140,5 @@
   {
   public:
+    virtual ~_connection_base4() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type, arg4_type) = 0;
@@ -147,4 +152,5 @@
   {
   public:
+    virtual ~_connection_base5() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type, arg4_type,
@@ -161,4 +167,5 @@
   {
   public:
+    virtual ~_connection_base6() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type, arg4_type, arg5_type,
@@ -175,4 +182,5 @@
   {
   public:
+    virtual ~_connection_base7() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type, arg4_type, arg5_type,
@@ -189,4 +197,5 @@
   {
   public:
+    virtual ~_connection_base8() {};
     virtual has_slots<mt_policy>* getdest() const = 0;
     virtual void emit(arg1_type, arg2_type, arg3_type, arg4_type, arg5_type,
Index: trunk/src/lib/util/substring.cc
===================================================================
--- trunk/src/lib/util/substring.cc	(revision 9682)
+++ trunk/src/lib/util/substring.cc	(revision 9869)
@@ -51,4 +51,5 @@
  * @param delimiters multiple set of characters at what to split. (delimiters)
  * @param delimiterNeighbours neighbours of the delimiters, that will be erased only when near a delimiter.
+ * @param emptyEntries If empty entries should be allewed or removed.
  * @param escapeChar The Escape Character that overrides splitters commends and so on...
  * @param safemode_char within these characters splitting won't happen
@@ -109,4 +110,6 @@
 /** @brief Helper that gets you a String consisting of all WhiteSpaces and the Comma */
 const std::string SubString::WhiteSpacesWithComma = " \n\t,";
+/** An Empty SubString */
+const SubString SubString::NullSubString = SubString();
 
 /**
@@ -145,4 +148,5 @@
  * @brief comparator.
  * @param subString the SubString to compare against this one.
+ * @param length how many entries to compare. (from 0 to length)
  * @returns true if the Stored Strings match
  */
@@ -273,9 +277,8 @@
  * @brief splits line into tokens and stores them in ret.
  * @param ret the Array, where the Splitted strings will be stored in
- * @param offsets an Array of Offsets, here the distance from the inputstring
  * to the beginning of the current token is stored
  * @param line the inputLine to split
  * @param delimiters a String of Delimiters (here the input will be splitted)
- * @param delimiterNeighbour Naighbours to the Delimitter, that will be removed if they are to the left or the right of a Delimiter.
+ * @param delimiterNeighbours Naighbours to the Delimitter, that will be removed if they are to the left or the right of a Delimiter.
  * @param emptyEntries: if empty Strings are added to the List of Strings.
  * @param escape_char: Escape carater (escapes splitters)
Index: trunk/src/lib/util/substring.h
===================================================================
--- trunk/src/lib/util/substring.h	(revision 9682)
+++ trunk/src/lib/util/substring.h	(revision 9869)
@@ -33,10 +33,11 @@
 {
 public:
+  //! An enumerator for the State the Parser is in
   typedef enum {
-    SL_NORMAL,
-    SL_ESCAPE,
-    SL_SAFEMODE,
-    SL_SAFEESCAPE,
-    SL_COMMENT,
+    SL_NORMAL,            //!< Normal state
+    SL_ESCAPE,            //!< After an escape character
+    SL_SAFEMODE,          //!< In safe mode (between "" mostly).
+    SL_SAFEESCAPE,        //!< In safe mode with the internal escape character, that escapes even the savemode character.
+    SL_COMMENT,           //!< In Comment mode.
   } SPLIT_LINE_STATE;
 
@@ -48,6 +49,6 @@
             const std::string& delimiters, const std::string& delimiterNeighbours = "", bool emptyEntries=false,
             char escapeChar ='\\', char safemode_char = '"', char comment_char = '\0');
+  SubString(unsigned int argc, const char** argv);
   /** @brief create a Substring as a copy of another one. @param subString the SubString to copy. */
-  SubString(unsigned int argc, const char** argv);
   SubString(const SubString& subString) { *this = subString; };
   SubString(const SubString& subString, unsigned int subSetBegin);
@@ -110,4 +111,5 @@
   static const std::string WhiteSpaces;
   static const std::string WhiteSpacesWithComma;
+  static const SubString   NullSubString;
 
 private:
